# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@lightly.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from lightly.openapi_generated.swagger_client.configuration import Configuration


class DockerRunCreateRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'docker_version': 'str',
        'dataset_id': 'MongoObjectID',
        'scheduled_id': 'MongoObjectID',
        'config_id': 'MongoObjectID',
        'message': 'str'
    }

    attribute_map = {
        'docker_version': 'dockerVersion',
        'dataset_id': 'datasetId',
        'scheduled_id': 'scheduledId',
        'config_id': 'configId',
        'message': 'message'
    }

    def __init__(self, docker_version=None, dataset_id=None, scheduled_id=None, config_id=None, message=None, _configuration=None):  # noqa: E501
        """DockerRunCreateRequest - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._docker_version = None
        self._dataset_id = None
        self._scheduled_id = None
        self._config_id = None
        self._message = None
        self.discriminator = None

        self.docker_version = docker_version
        if dataset_id is not None:
            self.dataset_id = dataset_id
        if scheduled_id is not None:
            self.scheduled_id = scheduled_id
        if config_id is not None:
            self.config_id = config_id
        if message is not None:
            self.message = message

    @property
    def docker_version(self):
        """Gets the docker_version of this DockerRunCreateRequest.  # noqa: E501


        :return: The docker_version of this DockerRunCreateRequest.  # noqa: E501
        :rtype: str
        """
        return self._docker_version

    @docker_version.setter
    def docker_version(self, docker_version):
        """Sets the docker_version of this DockerRunCreateRequest.


        :param docker_version: The docker_version of this DockerRunCreateRequest.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and docker_version is None:
            raise ValueError("Invalid value for `docker_version`, must not be `None`")  # noqa: E501

        self._docker_version = docker_version

    @property
    def dataset_id(self):
        """Gets the dataset_id of this DockerRunCreateRequest.  # noqa: E501


        :return: The dataset_id of this DockerRunCreateRequest.  # noqa: E501
        :rtype: MongoObjectID
        """
        return self._dataset_id

    @dataset_id.setter
    def dataset_id(self, dataset_id):
        """Sets the dataset_id of this DockerRunCreateRequest.


        :param dataset_id: The dataset_id of this DockerRunCreateRequest.  # noqa: E501
        :type: MongoObjectID
        """

        self._dataset_id = dataset_id

    @property
    def scheduled_id(self):
        """Gets the scheduled_id of this DockerRunCreateRequest.  # noqa: E501


        :return: The scheduled_id of this DockerRunCreateRequest.  # noqa: E501
        :rtype: MongoObjectID
        """
        return self._scheduled_id

    @scheduled_id.setter
    def scheduled_id(self, scheduled_id):
        """Sets the scheduled_id of this DockerRunCreateRequest.


        :param scheduled_id: The scheduled_id of this DockerRunCreateRequest.  # noqa: E501
        :type: MongoObjectID
        """

        self._scheduled_id = scheduled_id

    @property
    def config_id(self):
        """Gets the config_id of this DockerRunCreateRequest.  # noqa: E501


        :return: The config_id of this DockerRunCreateRequest.  # noqa: E501
        :rtype: MongoObjectID
        """
        return self._config_id

    @config_id.setter
    def config_id(self, config_id):
        """Sets the config_id of this DockerRunCreateRequest.


        :param config_id: The config_id of this DockerRunCreateRequest.  # noqa: E501
        :type: MongoObjectID
        """

        self._config_id = config_id

    @property
    def message(self):
        """Gets the message of this DockerRunCreateRequest.  # noqa: E501


        :return: The message of this DockerRunCreateRequest.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this DockerRunCreateRequest.


        :param message: The message of this DockerRunCreateRequest.  # noqa: E501
        :type: str
        """

        self._message = message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DockerRunCreateRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DockerRunCreateRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DockerRunCreateRequest):
            return True

        return self.to_dict() != other.to_dict()
